#!/bin/python
# Persistent homology of wifi data
#
# Copyright (c) 2015, Michael Robinson
# Distribution of unaltered copies permitted for noncommercial use only
# All other uses require express permission of the author
# This software comes with no warrantees express or implied

import os
import numpy as np
import matplotlib.pyplot as plt

filename='eight'
scale=20

with open(filename + '.csv','rt') as f1:
    f1.readline()
    line=f1.readline()
    data=line.split(',')
    with open(filename+'_perseus_input.txt','wt') as f2:
        f2.write(str(len(data))+'\n') # Ambient dimension
        f2.write('1 .5 '+ str(scale) +'\n') # Radius scale, step size, number of steps
    
        for line in f1:
            lst=line.split(',')
            f2.write(' '.join(lst) + ' 1\n') # Note initial radius at end of line

os.system('perseus brips ' + filename + '_perseus_input.txt ' + filename + '_perseus_output' )

plt.hold(False)
with open( filename + '_perseus_output_0.txt') as fp:
    pts=[map(float,line.split()) for line in fp]
    if pts:
        ax=plt.subplot(132,aspect='equal')
        x,y=zip(*pts)
        plt.plot(x,y,'.',ms=4*np.pi)
        plt.hold(True)
        plt.plot([0,scale],[0,scale])
        plt.xlabel('Birth')
        plt.ylabel('Death')
        plt.title('Persistent H0')
        
with open( filename + '_perseus_output_1.txt') as fp:
    pts=[map(float,line.split()) for line in fp]
    if pts:
        plt.subplot(133,aspect='equal')
        x,y=zip(*pts)
        plt.plot(x,y,'.',ms=4*np.pi)
        plt.hold(True)
        plt.plot([0,scale],[0,scale])
        plt.hold(False)
        plt.xlabel('Birth')
        plt.ylabel('Death')
        plt.title('Persistent H1')
        
plt.subplots_adjust(wspace=0.5)
plt.savefig( filename + '_persistence.png')

plt.show()
