#!/bin/python
# Principal components analysis of ocean buoy spectrum
#
# Copyright (c) 2015, Michael Robinson
# Distribution of unaltered copies permitted for noncommercial use only
# All other uses require express permission of the author
# This software comes with no warrantees express or implied

import numpy as np
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt

# Ingest data
pts=[]
with open('46089.data_spec','rt') as f1:
    f1.readline() # Skip header
    for line in f1:
        lst=line.split(' ')
        pts.append(np.array(map(float,lst[6:-1:2])))

# Run PCA for visualization
ptsmat=np.array(pts).T
u,s,v=np.linalg.svd(np.dot(ptsmat,ptsmat.T))
locations=np.dot(v[0:3,:],ptsmat).T

# Plot the result
fig=plt.figure()
ax=Axes3D(fig)
ax.hold(True)
ax.scatter(locations[:,0],locations[:,1],locations[:,2])
plt.show()
